
from .common import MatchSeries

class Filter(MatchSeries):
  def __init__(self, field = None, value = None, **kwargs) -> None:
    super().__init__(**kwargs)
    self._field = field
    self._value = value

  def execute(self, values):
    for measurement in values:
      dataset = self.get_series(measurement)

      if not dataset:
        continue

      if self._field:
        value = getattr(dataset, self._field, None)
        if not value:
          continue
        if self._value and self._value != value:
          continue
      
      yield measurement
      
      

